package EDU.bmrb.net;
import java.lang.*;

/** Thrown when there is an error reported by the web server via
  * an HTTP status (example: 404 Not Found)
  */
public class HTTPException extends Exception
{
    private String msg;

    /** @param msgPassed the string returned by the server,
      *       for example: "HTTP/1.0 400 Not Found"
      */
    public HTTPException( String msgPassed )
    {
	super();
	msg = msgPassed;
    }

    /** Returns the string status, for example: "HTTP/1.0 404 Not Found"
      * @return the string status, for example: "HTTP/1.0 404 Not Found"
      */
    public String getMessage()
    {
	return msg;
    }
}
