/*
	A basic extension of the java.applet.Applet class
 */

import java.awt.*;
import java.applet.*;
import java.io.*;

public class Applet1 extends Applet
{
	public void init()
	{
		// Take out this line if you don't use symantec.itools.net.RelativeURL or symantec.itools.awt.util.StatusScroller
		symantec.itools.lang.Context.setApplet(this);
	
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setLayout(null);
		setBackground(java.awt.Color.lightGray);
		setSize(527,605);
		titleLabel.setText("Simple File Access Sandbox tester.");
		add(titleLabel);
		titleLabel.setFont(new Font("Dialog", Font.BOLD, 16));
		titleLabel.setBounds(12,12,384,24);
		instructions.setEditable(false);
		instructions.setText(
		    "This small applet just tests the reading and writing of a file in your\n" +
		    "sandbox.  Enter the name of a file on your local machine, and the applet\n" +
		    "will attempt to read that file and copy it to a new filename with a *.two\n" +
		    "extension.  This tests the security settings of your sandbox.\n\n" +
		    "TO VIEW RESULTS:  If nothing appears to happen, in Netscape, look at the\n" +
		    "    \"Java Console\" under the \"Tools\" submenu to see what the error was.\n" +
		    "    (It is probably a security violation.)\n" );

		add(instructions);
		instructions.setBackground(java.awt.Color.lightGray);
		instructions.setFont(new Font("SansSerif", Font.PLAIN, 12));
		instructions.setBounds(24,36,468,204);
		inFileNameLabel.setText("Enter local filename;");
		add(inFileNameLabel);
		inFileNameLabel.setBounds(156,300,168,24);
		add(inFileNameField);
		inFileNameField.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		inFileNameField.setBounds(24,324,384,36);
		goButton.setLabel("Go");
		add(goButton);
		goButton.setBackground(java.awt.Color.lightGray);
		goButton.setBounds(420,324,48,24);
		statusLabel.setText("Status:");
		add(statusLabel);
		statusLabel.setBounds(204,372,144,24);
		statusText.setEditable(false);
		statusText.setEnabled(false);
		add(statusText);
		statusText.setBackground(java.awt.Color.white);
		statusText.setForeground(java.awt.Color.magenta);
		statusText.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		statusText.setBounds(24,396,468,72);
		//}}
	
		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		goButton.addActionListener(lSymAction);
		//}}
	}
	
	//{{DECLARE_CONTROLS
	java.awt.Label titleLabel = new java.awt.Label();
	java.awt.TextArea instructions = new java.awt.TextArea("",0,0,TextArea.SCROLLBARS_NONE);
	java.awt.Label inFileNameLabel = new java.awt.Label();
	java.awt.TextField inFileNameField = new java.awt.TextField();
	java.awt.Button goButton = new java.awt.Button();
	java.awt.Label statusLabel = new java.awt.Label();
	java.awt.TextArea statusText = new java.awt.TextArea();
	//}}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == goButton)
				goButton_ActionPerformed(event);
		}
	}

	void goButton_ActionPerformed(java.awt.event.ActionEvent event)
	{
		String inFileName = inFileNameField.getText();
		int  dotPos = inFileName.lastIndexOf( '.' );
		dotPos = dotPos >= 0 ? dotPos : inFileName.length();
		String outFileName = inFileName.substring(0,dotPos) + ".two";
		FileInputStream inFile = null;
		FileOutputStream outFile = null;
		
		try
		{   inFile = new FileInputStream( inFileName );
		}
		catch( IOException e )
		{   statusText.setText( "Error opening " + inFileName + " for input:\n" +
		                        e.getMessage() );
		    return;
		}
		try
		{   outFile = new FileOutputStream( outFileName );
		}
		catch( IOException e )
		{   statusText.setText( "Error opening " + outFileName + " for output:\n" +
		                        e.getMessage() );
		    return;
		}
		
		try
		{   outFile = new FileOutputStream( outFileName );
			int ch = 0;
		    while( ch != -1 )
	        {
	            ch = inFile.read();
	            if( ch != -1 )
	                outFile.write(ch);
		    }
		}
		catch( IOException e )
		{   statusText.setText( "Error writing or reading:\n" +
		                        e.getMessage() );
		    return;
		}
	    
	    try
	    {
	        outFile.close();
	        inFile.close();
	    }
	    catch( IOException e )
	    {   statusText.setText( "Error closing files:\n" + e.getMessage() );
	    }
	    
	    // If it got this far, it worked.
	    statusText.setText( "Done." );
	    return;
	}
}
